{
===================
E X S P O R T E R S
===================
Version 1.0

!!!!!!!!!! a open export interface !!!!!!!!!!

Copyright 10.1997 By MAD Soft

Telephone: Bulgaria, Sofia, 37-06-23
E_Mail:    NMMM@NSI.BG
           NMMM@HotMail.Com
Web:       Http:\\WWW.NSI.BG\NMMM\Home.Htm

==============================================

Hierarchie Tree:
                                  -------Text
                                 /
              ------------File(8)=-------HTML(*)(1)
             /                   \
            /                     -------GRV(*)(2)
           /                       \
Abstract(8)=--------------Printer   -----RFT(*)(3)
           \
            --------------Memo
             \
              ------------?Post_Script?(4)

==============================================

(8)    Abstract Object
(*)    In external PAS file
(1)    HTML Exporter is shareware!!!!!! See HTMLExp documentation for details.
(2)    Gunev Report Viewer. Copyright by Vasil Gounev ( VAGSoft@HotMail.Com )
(3)    Based on unit by Vasil Gounev ( VAGSoft@HotMail.Com ).
       Contact with me for this exporter.
(4)    Do u know PostScript? I no!
       If u know how - create and send me file, please ;))))

}

unit BasicExp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Printers, StdCtrls;

Type TExpAlign       = (REAlignNone,
                        REAlignLeft,REAlignCenter,REAlignRight,
                        REAlignJust);

     TExpFontStyle   = Set Of (REBold,REItalic,REUnderline,
                               RETeleType);
     TExpFontSize    = 1..10;
     TExpBorder      = Byte;

type
  TAbstractExporter = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    Procedure Open; Virtual;
    Procedure Close; Virtual;

    Procedure BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle); Virtual;
    Procedure Paragraph(S:String); Virtual;
    Procedure EndParagraph; Virtual;

    Procedure QuickParagraph(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);

    Procedure IndentPlus; Virtual;
    Procedure IndentMinus; Virtual;

    Procedure BeginTable(Border:TExpBorder); Virtual;
    Procedure BeginRow; Virtual;
    Procedure Cell(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle); Virtual;
    Procedure EndRow; Virtual;
    Procedure EndTable; Virtual;
  published
    { Published declarations }
  end;

type
  TFileExporter = class(TAbstractExporter)
  private
    { Private declarations }
    FFileName      : TFileName;
    FOverWriteFile : Boolean;
  protected
    { Protected declarations }

    property OverWriteFile : Boolean   Read FOverWriteFile Write FOverWriteFile;
  public
    F         : TextFile;

    { Public declarations }
    Constructor Create(AOwner:TComponent); OverRide;

    Procedure   Open; OverRide;
    Procedure   Close; OverRide;
  published
    { Published declarations }
    property FileName      : TFileName Read FFileName      Write FFileName;
  end;

type
  TTextExporter = class(TFileExporter)
  private
    { Private declarations }
    FOEMConvert : Boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); OverRide;

    Procedure   Paragraph(S:String); OverRide;
    Procedure   EndParagraph; OverRide;
  published
    { Published declarations }
    property OEMConvert : Boolean Read FOEMConvert Write FOEMConvert;
    Property OverWriteFile; {From TFileExporter}
  end;

type
  TPrinterExporter = class(TAbstractExporter)
  private
    { Private declarations }
    F         : TextFile;

    FOrientation : TPrinterOrientation;
    FFont : TFont;

    Procedure SetFont(AFont:TFont);
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); OverRide;
    Destructor  Destroy; OverRide;

    Procedure   Paragraph(S:String); OverRide;
    Procedure   EndParagraph; OverRide;

    Procedure   Open; OverRide;
    Procedure   Close; OverRide;

  published
    { Published declarations }
    Property Orientation : TPrinterOrientation Read FOrientation Write FOrientation;
    Property Font        : TFont               Read FFont        Write SetFont;
  end;

type
  TMemoExporter = class(TAbstractExporter)
  private
    { Private declarations }
    FMemo        : TMemo;
    MemoLine     : String;
  protected
    { Protected declarations }
  public
    { Public declarations }
    Procedure Open; OverRide;

    Procedure BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle); OverRide;
    Procedure Paragraph(S:String); OverRide;
    Procedure EndParagraph; OverRide;
  published
    { Published declarations }
    Property Memo : TMemo Read FMemo Write FMemo;
  end;

procedure Register;

implementation

procedure Register;
begin
  {In fact first two components no need in VCL palette}
{
  RegisterComponents('Exporter', [TAbstractExporter]);
  RegisterComponents('Exporter', [TFileExporter]);
}
  RegisterComponents('Exporter', [TTextExporter]);
  RegisterComponents('Exporter', [TPrinterExporter]);
  RegisterComponents('Exporter', [TMemoExporter]);
end;

Procedure TAbstractExporter.Open;
   Begin
   End;

Procedure TAbstractExporter.Close;
   Begin
   End;

Procedure TAbstractExporter.BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
   End;

Procedure TAbstractExporter.Paragraph(S:String);
   Begin
   End;

Procedure TAbstractExporter.EndParagraph;
   Begin
   End;

Procedure TAbstractExporter.QuickParagraph(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
      Self.BeginParagraph(Align,FontSize,FontStyle);
      Self.Paragraph(S);
      Self.EndParagraph;
   End;

Procedure TAbstractExporter.IndentPlus;
   Begin
   End;

Procedure TAbstractExporter.IndentMinus;
   Begin
   End;

Procedure TAbstractExporter.BeginTable(Border:TExpBorder);
   Begin
   End;

Procedure TAbstractExporter.BeginRow;
   Begin
      BeginParagraph(REAlignNone,10,[]);
   End;

Procedure TAbstractExporter.Cell(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
      Paragraph(S);
      Paragraph(''+#9);
   End;

Procedure TAbstractExporter.EndRow;
   Begin
      EndParagraph;
   End;

Procedure TAbstractExporter.EndTable;
   Begin
   End;

{======================================================================}

Constructor TFileExporter.Create(AOwner:TComponent);
   Begin
      Inherited Create(AOwner);
      FOverWriteFile:=True;
   End;

Procedure TFileExporter.Open;
   Begin
      Inherited Open;

      AsSignFile(F,FFileName);
      If FOverWriteFile Then
         ReWrite(F)
      Else
         Append(F);
   End;

Procedure TFileExporter.Close;
   Begin
      CloseFile(F);

      Inherited Close;
   End;

{======================================================================}

Constructor TTextExporter.Create(AOwner:TComponent);
   Begin
      Inherited Create(AOwner);
      FOEMConvert:=False;
   End;

Procedure   TTextExporter.Paragraph(S:String);
   Var SO : String;
   Begin
      If FOEMConvert Then
         AnsiToOEMBuff(@S[1], @SO[1], Length(S) )
      Else
         SO:=S;

      Write(F,SO);
   End;

Procedure   TTextExporter.EndParagraph;
   Begin
      WriteLn(F);
   End;

{======================================================================}

Constructor TPrinterExporter.Create(AOwner:TComponent);
   Begin
      Inherited Create(AOwner);

      FFont:=TFont.Create;
   End;

Destructor  TPrinterExporter.Destroy;
   Begin
      FFont.Destroy;

      Inherited Destroy;
   End;

Procedure TPrinterExporter.Open;
   Begin
      Inherited Open;

      Printer.Orientation:=FOrientation;
      Printer.Canvas.Font:=FFont;

      AsSignPrn(F);
      ReWrite(F);
   End;

Procedure TPrinterExporter.Close;
   Begin
      CloseFile(F);

      Inherited Close;
   End;

Procedure   TPrinterExporter.Paragraph(S:String);
   Begin
      Write(F,S);
   End;

Procedure   TPrinterExporter.EndParagraph;
   Begin
      WriteLn(F);
   End;

Procedure TPrinterExporter.SetFont(AFont:TFont);
   Begin
      FFont.AsSign(AFont);
   End;
{======================================================}

Procedure TMemoExporter.Open;
   Begin
      Inherited Open;
      If AsSigned(FMemo) Then
         FMemo.Clear;
   End;

Procedure TMemoExporter.BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
      MemoLine:='';
   End;

Procedure TMemoExporter.Paragraph(S:String);
   Begin
      MemoLine:=MemoLine + S;
   End;

Procedure TMemoExporter.EndParagraph;
   Begin
      Try
         If AsSigned(FMemo) Then
            FMemo.Lines.Add(MemoLine);
      Except
      End;{Try}
   End;

end.
