{
GReader Exporter Component
Version 1.0

Copyright 10.1997 By MAD Soft

Telephone: Bulgaria, Sofia, 37-06-23
E_Mail:    NMMM@NSI.BG
           NMMM@HotMail.Com
Web:       Http:\\WWW.NSI.BG\NMMM\Home.Htm

Notes:
   (o) GReader is copyright by V. Gounev ( VAGSoft@HotMail.Com )
   (o) This is only exporter, U must register GReader !!!!

}

Unit GRVExp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, BasicExp;

type
  TPage        = Record
                    Width,
                    Height  : Word;

                    Left,
                    Right,
                    Top,
                    Bottom  : Word;
                 End;

  TGRVExporter = class(TFileExporter)
  private
    { Private declarations }
    FReportName  : String;
    FPage        : TPage;
    FFont        : TFont;
    FTabStops    : String;

    Procedure SetFont(AFont:TFont);
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner:TComponent); OverRide;
    Destructor  Destroy; OverRide;

    Procedure Open; OverRide;

    Procedure BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle); OverRide;
    Procedure Paragraph(S:String); OverRide;
    Procedure EndParagraph; OverRide;

    Procedure BeginRow; OverRide;
    Procedure Cell(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle); OverRide;
    Procedure EndRow; OverRide;
  published
    { Published declarations }
    Property ReportName  : String      Read FReportName  Write FReportName;

    Property PageWidth   : Word        Read FPage.Width  Write FPage.Width;
    Property PageHeight  : Word        Read FPage.Height Write FPage.Height;

    Property PageTop     : Word        Read FPage.Top    Write FPage.Top;
    Property PageBottom  : Word        Read FPage.Bottom Write FPage.Bottom;
    Property PageLeft    : Word        Read FPage.Left   Write FPage.Left;
    Property PageRight   : Word        Read FPage.Right  Write FPage.Right;

    Property Font        : TFont       Read FFont        Write SetFont;

    Property TabStops    : String      Read FTabStops    Write FTabStops;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Exporter', [TGRVExporter]);
end;

Constructor TGRVExporter.Create(AOwner:TComponent);
   Begin
      Inherited Create(AOwner);

      FFont:=TFont.Create;

      FPage.Width:=210;
      FPage.Height:=297;
      FPage.Left:=20;
      FPage.Right:=20;
      FPage.Top:=20;
      FPage.Bottom:=20;

      FTabStops:='1,50,100,150,170';
   End;

Destructor  TGRVExporter.Destroy;
   Begin
      FFont.Destroy;

      Inherited Destroy;
   End;

Procedure TGRVExporter.SetFont(AFont:TFont);
   Begin
      FFont.AsSign(AFont);
   End;

Procedure TGRVExporter.Open;
   Begin
      Inherited Open;

      WriteLn(f,ReportName);                   {Name of the report}

      WriteLn(f,'1.00');                       {Format version}

      WriteLn(f,FPage.Width,',',FPage.Height); {Width and Height of the page in mm}

      WriteLn(f,FPage.Left,',',FPage.Right,',',FPage.Top,',',FPage.Bottom);
                                               {Left, Right, Top, Bottom margins in mm}

      WriteLn(f,FFont.Name,',',FFont.Size);    {Font Name and Size}

      WriteLn(f,FTabStops);                    {TabStops in mm}

      WriteLn(f,'5,2');              {Where to show Page Number, Report Name :}
                                     {0-None; 1:Top Left; 2:Top Center; 3:Top Right; 4:Bottom Left;}
                                     {5:Bottom Center; 6:Bottom Right;}

      WriteLn(f);                    {Reserved row for future versions}
      WriteLn(f);
      WriteLn(f);
      WriteLn(f);
   End;

Procedure TGRVExporter.BeginParagraph(Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
      Write(F,'^');

      Case Align Of
         REAlignRight   :Write(F,'R');
         REAlignCenter  :Write(F,'C');
         REAlignJust    :Write(F,'J');
      Else
         Write(F,'L');
      End;{CASE}

      If REBold      In FontStyle Then Write(F,'B');
      If REItalic    In FontStyle Then Write(F,'I');
      If REUnderline In FontStyle Then Write(F,'U');

      Write(F,'^');
   End;

Procedure TGRVExporter.Paragraph(S:String);
   Begin
      Write(F,S);
   End;

Procedure TGRVExporter.EndParagraph;
   Begin
      WriteLn(F);
   End;

Procedure TGRVExporter.BeginRow;
   Begin
      Write(F,'^T^');
   End;

Procedure TGRVExporter.Cell(S:String;Align:TExpAlign;FontSize:TExpFontSize;FontStyle:TExpFontStyle);
   Begin
      BeginParagraph(Align,FontSize,FontStyle);

      Write(F,''+#9);
      Write(F,S);
   End;

Procedure TGRVExporter.EndRow;
   Begin
      WriteLn(F);
   End;

end.
